/* cantProceed */
#ifndef INCcantProceedh
#define INCcantProceedh

#ifdef __cplusplus
extern "C" {
#endif

#include <vxWorks.h>
#include <taskLib.h>
#include <fioLib.h>
#include <string.h>
#include <assert.h>

#define cantProceed(m) \
{ \
    printErr("FATAL: %s can't proceed in %s line %d %s\n", \
        (m), __FILE__, __LINE__); taskSuspend(0); }

#define callocMustSucceed(n,s,m) __extension__ \
({ \
    void *mem = calloc((n),(s)); \
    if (!mem) { printErr("FATAL: %s callocMustSucceed failed in %s line %d: %s\n", \
        (m), __FILE__, __LINE__, strerror(errno)); taskSuspend(0); } \
    mem; \
})

#define mallocMustSucceed(s,m) __extension__ \
({ \
    void *mem = malloc(s); \
    if (!mem) { printErr("FATAL: %s mallocMustSucceed failed in %s line %d: %s\n", \
        (m), __FILE__, __LINE__, strerror(errno)); taskSuspend(0); } \
    mem; \
})

#ifdef __cplusplus
}
#endif

#endif
