/* epicsThread */
#ifndef epicsThreadh
#define epicsThreadh

#ifdef __cplusplus
extern "C" {
#endif

#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h>

#define EPICSTHREADFUNC FUNCPTR

#define epicsThreadPriorityMax          99
#define epicsThreadPriorityMin           0
#define epicsThreadPriorityLow          10
#define epicsThreadPriorityMedium       50
#define epicsThreadPriorityHigh         90
#define epicsThreadPriorityCAServerLow  20
#define epicsThreadPriorityCAServerHigh 40
#define epicsThreadPriorityScanLow      66
#define epicsThreadPriorityScanHigh     71
#define epicsThreadPriorityIocsh        91
#define epicsThreadPriorityBaseMax      91

typedef enum {
    epicsThreadStackSmall, epicsThreadStackMedium, epicsThreadStackBig
} epicsThreadStackSizeClass;

extern const unsigned stackSizeTable[epicsThreadStackBig+1];

#define epicsThreadId void*

#define epicsThreadCreate(name, pri, stack, func, args) \
    (void*)taskSpawn((char*)(name), 255-(pri)*255/99, VX_FP_TASK, (stack), (FUNCPTR)(func), (int)(args), \
    0,0,0,0,0,0,0,0,0)
    
#define epicsThreadSleep(sec) taskDelay((sec)*sysClkRateGet())
#define epicsThreadIsSuspended(t) (taskIdVerify((int)(t)) || taskIsSuspended((int)(t)))
#define epicsThreadGetIdSelf() taskIdSelf()
#define epicsThreadGetStackSize(s) stackSizeTable[s]

#ifdef __cplusplus
}
#endif

#endif
