/* epicsTimer */

#ifndef epicsTimerH
#define epicsTimerH

#include <vxWorks.h>
#include <sysLib.h>
#include <wdLib.h>
#include <callback.h>

#ifdef __cplusplus
extern "C" {
#endif

#define epicsTimerQueueId int
#define epicsTimerQueueAllocate(okToShare,threadPriority) \
    ((threadPriority)<=epicsThreadPriorityScanLow?0: \
    (threadPriority)>=epicsThreadPriorityScanHigh?2:1)
typedef void (*epicsTimerCallback) (void* pPrivate);
typedef struct epicsTimerForC {CALLBACK cb; WDOG_ID wd; epicsTimerCallback func;} *epicsTimerId;

void compatTimerCallbackWrapper (CALLBACK* pcb);

#define epicsTimerQueueCreateTimer(queue, callbackfunc, param) __extension__ \
({ \
    epicsTimerId ti = calloc(1, sizeof(struct epicsTimerForC)); \
    ti->wd = wdCreate(); \
    callbackSetCallback(compatTimerCallbackWrapper, &ti->cb); \
    callbackSetPriority(queue, &ti->cb); \
    callbackSetUser(param, &ti->cb); \
    ti->func = callbackfunc; \
    ti; \
})

#define epicsTimerStartDelay(ti,delay) \
    (void) wdStart((ti)->wd, (int)((delay)*sysClkRateGet()), \
        (FUNCPTR)callbackRequest, (int)&(ti)->cb)

#define epicsTimerCancel(ti) wdCancel(ti->wd)

#endif

#ifdef __cplusplus
}
#endif
